namespace CMSMicroservice.Application.UserWalletHistoryCQ.Commands.UpdateUserWalletHistory;
public class UpdateUserWalletHistoryCommandValidator : AbstractValidator<UpdateUserWalletHistoryCommand>
{
    public UpdateUserWalletHistoryCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.WalletId)
            .NotNull();
        RuleFor(model => model.CurrentBalance)
            .NotNull();
        RuleFor(model => model.ChangeValue)
            .NotNull();
        RuleFor(model => model.CurrentNetworkBalance)
            .NotNull();
        RuleFor(model => model.ChangeNerworkValue)
            .NotNull();
        RuleFor(model => model.IsIncrease)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserWalletHistoryCommand>.CreateWithOptions((UpdateUserWalletHistoryCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
